﻿Imports System
Imports Autodesk.AutoCAD.Runtime
Imports Autodesk.AutoCAD.ApplicationServices
Imports Autodesk.AutoCAD.DatabaseServices
Imports Autodesk.AutoCAD.Geometry
Imports Autodesk.AutoCAD.EditorInput

<Assembly: CommandClass(GetType(dotNetTraining_Webcast_Demos.Webcast_2_Demos))> 

Namespace dotNetTraining_Webcast_Demos


    Class Webcast_2_Demos

        <CommandMethod("demoKeywords")> _
        Public Sub keywordDemo()

            ' get editor
            Dim ed As Editor = Application.DocumentManager.MdiActiveDocument.Editor


            Dim keyWordOpts As PromptKeywordOptions = New PromptKeywordOptions("")

            ' add a message for the command line
            keyWordOpts.Message = vbLf & "Enter your color choice: "

            ' Add some keywords 
            keyWordOpts.Keywords.Add("Red")
            keyWordOpts.Keywords.Add("Green")
            keyWordOpts.Keywords.Add("Blue")

            ' ensure that we get something
            keyWordOpts.AllowNone = False

            ' add the message and keywords
            keyWordOpts.AppendKeywordsToMessage = True

            ' get the keywords
            Dim keyWordRes As PromptResult = ed.GetKeywords(keyWordOpts)

            ' check the status
            If keyWordRes.Status = PromptStatus.OK Then
                ' put value on command line
                ed.WriteMessage("Your color = " & keyWordRes.StringResult)
            Else
                ' problem getting color
                ed.WriteMessage("Problem getting the color")
            End If
        End Sub

        <CommandMethod("demoDistance")> _
        Public Sub distanceDemo()
            ' get editor
            Dim ed As Editor = Application.DocumentManager.MdiActiveDocument.Editor

            ' get PromptPointOptions
            Dim prmptPointOpts As PromptPointOptions = _
                New PromptPointOptions(vbCrLf & "Pick a point:")

            ' get a promptPointResult
            Dim prmptPointRes As PromptPointResult

            ' get the point
            prmptPointRes = ed.GetPoint(prmptPointOpts)

            ' check for ok
            If prmptPointRes.Status = PromptStatus.OK Then

                Dim pnt1 As Point3d
                ' get the point from the PromptPointResult
                pnt1 = prmptPointRes.Value

                ' put the xyz of the point on the command line
                ed.WriteMessage(vbCrLf & "X,Y,Z of first point = " & pnt1.ToString)

                ' get promptPointDistanceOptions
                Dim prmptDistanceOpts As PromptDistanceOptions = _
                    New PromptDistanceOptions(vbCrLf & "Pick second point:")

                ' set the base point
                prmptDistanceOpts.BasePoint = pnt1

                ' use a base point
                prmptDistanceOpts.UseBasePoint = True

                ' get the 
                Dim prmptDoubleRes As PromptDoubleResult
                ' get the distance (double)
                prmptDoubleRes = ed.GetDistance(prmptDistanceOpts)

                If prmptDoubleRes.Status = PromptStatus.OK Then
                    ed.WriteMessage(vbCrLf & "Distance between points = " _
                                    & prmptDoubleRes.Value.ToString)
                Else
                    ed.WriteMessage(vbCrLf & "Problem getting second point for distance ")
                End If

            Else
                ed.WriteMessage("Problem getting first point ")
            End If

        End Sub

        <CommandMethod("demoGetEntity")> _
        Public Sub getEntityDemo()

            Dim ed As Editor = Application.DocumentManager.MdiActiveDocument.Editor

            ' Use PromptEntityOptions
            Dim prmptEntityOpts As PromptEntityOptions = _
                New PromptEntityOptions("Pick an entity")

            ' control whether or not user can select entities on locked layers
            prmptEntityOpts.AllowObjectOnLockedLayer = True

            ' Get the entity
            Dim prmptEntityRes As PromptEntityResult
            prmptEntityRes = ed.GetEntity(prmptEntityOpts)

            ' Check the status
            If prmptEntityRes.Status = PromptStatus.OK Then
                ed.WriteMessage(vbCrLf & "ObjectId of entity is: " & prmptEntityRes.ObjectId.ToString())
            Else
                ed.WriteMessage(vbCrLf & "Entity not selected")
            End If

        End Sub

        <CommandMethod("demoPickfirst", CommandFlags.UsePickSet)> _
        Public Sub DemoPickfirstSelection()

            Dim ed As Editor = Application.DocumentManager.MdiActiveDocument.Editor

            ' PromptSelectResult, get selected entities
            Dim prmptSelRes As PromptSelectionResult
            prmptSelRes = ed.SelectImplied()

            Dim SSet1 As SelectionSet

            ' make sure it is ok
            If prmptSelRes.Status = PromptStatus.OK Then
                SSet1 = prmptSelRes.Value

                ed.WriteMessage("Number of objects in Pickfirst selection: " & _
                                            SSet1.Count.ToString())
            Else
                ed.WriteMessage("Number of objects in Pickfirst selection: 0")
            End If
        End Sub


        '' Not in code in zip file
        <CommandMethod("testSS")> _
        Public Sub testSS()

            Dim ed As Editor = Application.DocumentManager.MdiActiveDocument.Editor


            Dim opt As PromptSelectionOptions = New PromptSelectionOptions()
            opt.Keywords.Add("First")

            opt.SelectEverythingInAperture = True

            'opt.SinglePickInSpace = True

            opt.SingleOnly = True

            Dim prmptSelRes As PromptSelectionResult

            prmptSelRes = ed.GetSelection(opt)
            If prmptSelRes.Status = PromptStatus.OK Then

                ed.WriteMessage(prmptSelRes.Value.Count)

            End If
        End Sub
    End Class
End Namespace